Option Explicit

Global CBType As Integer
Global CBLoc As String

Declare Function GetPrivateProfileString Lib "kernel" (ByVal lpSectionName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function ExitWindows Lib "User" (ByVal dwReturnCode As Long, ByVal wReserved As Integer) As Integer
Declare Sub GetCallInfo Lib "Callbook.DLL" (ByVal ADriveInfo As String, ByVal ACall As String, ByVal AInfo As String, AErrorCode As Integer)

Function AppPath () As String

    Dim MyPath As String

    MyPath = App.Path
    If Right(MyPath, 1) <> "\" Then MyPath = MyPath + "\"

    AppPath = MyPath

End Function

Function CBRAC (Callsign As String) As String

    Dim RetVal As String
    Dim ErrorType As Integer
    Dim Address As String
    Dim Pos As Integer
    
    'Get callsign info from Radio Amateur Callbook (RAC) CDROM
    RetVal = String(512, 0)
    GetCallInfo CBLoc, Callsign + Chr(0), RetVal, ErrorType
    
    Address = CBRACRetrieve(RetVal, 2)
    Pos = InStr(Address, ", ")
    
    'Change comma delimiters to new lines
    Do While Pos > 0
        Address = Left(Address, Pos - 1) + Chr(13) + Mid(Address, Pos + 2)
        Pos = InStr(Address, ", ")
    Loop
    
    'Retrieve complete data for US residents
    If CBRACRetrieve(RetVal, 17) = "USA" Then
        Address = Address + ", " + CBRACRetrieve(RetVal, 13) + " " + CBRACRetrieve(RetVal, 6) + " " + CBRACRetrieve(RetVal, 5)
    End If
    
    Dim Res As String
    If Len(Address) = 0 Then
        Res = ""
    Else
        Res = Chr(13) + CBRACRetrieve(RetVal, 16)
    End If
    CBRAC = Address + Res
    
End Function

Function CBRACRetrieve (Text As String, Field As Integer) As String

    Dim Pos As Integer
    Dim Result As String
    
    Pos = InStr(Text, Chr(Field))
    If Pos > 0 Then
        Result = Mid(Text, Pos + 1)
        For Pos = 1 To Len(Result)
            If Asc(Mid(Result, Pos, 1)) < 26 Then
                Result = Left(Result, Pos - 1)
                Exit For
            End If
        Next
    End If
    
    CBRACRetrieve = Result

End Function

Function ReadProfile (Section As String, Key As String) As String

    Dim Dummy As Integer
    Dim Result As String
    Dim Pos As Integer
    
    Result = String(255, 0)
    Dummy = GetPrivateProfileString(Section, Key, "", Result, Len(Result), AppPath() + "DXMaster.INI")
    
    Pos = InStr(Result, Chr(0))
    If Pos > 0 Then ReadProfile = Left(Result, Pos - 1)

End Function

